require 'loaded_die'

String == LoadedDie::VERSION.class or fail

Module == LoadedDie.class or fail

Class == LoadedDie::Sampler.class or fail

begin
  LoadedDie::Sampler.new(:a => 0)
rescue ArgumentError
else
  fail
end

begin
  LoadedDie::Sampler.new(:a => -1)
rescue ArgumentError
else
  fail
end

lambda do
  sampler = LoadedDie::Sampler.new({})
  sampler.respond_to?(:length) or fail
  sampler.respond_to?(:[]) or fail
  sampler.respond_to?(:sample) or fail
end.call

lambda do
  0 == LoadedDie::Sampler.new({}).length or fail
  2 == LoadedDie::Sampler.new({ :a => 2 }).length or fail
  (2 + 3.1) == LoadedDie::Sampler.new({ :a => 2, :b => 3.1 }).length or fail
end.call

lambda do
  sampler = LoadedDie::Sampler.new({})
  nil == sampler[0.42] or fail
end.call

lambda do
  sampler = LoadedDie::Sampler.new([[:a, 3], [:b, 2.0], [:c, 5]])
  nil == sampler[-1.0] or fail
  :a == sampler[0.0] or fail
  :a == sampler[2.99] or fail
  :b == sampler[3] or fail
  :b == sampler[3.0] or fail
  :b == sampler[4.99] or fail
  :c == sampler[5.0] or fail
  :c == sampler[9.99] or fail
  nil == sampler[10.0] or fail
  nil == sampler[11.0] or fail
end.call

lambda do
  sampler = LoadedDie::Sampler.new({})
  nil == sampler.sample or fail
end.call

lambda do
  sampler = LoadedDie::Sampler.new([[:a, 3], [:b, 2.0], [:c, 9001]])
  rng = Object.new
  def rng.rand(n)
    (3 + 2.0 + 9001) == n or fail
    4.99
  end
  :b == sampler.sample(:random => rng) or fail
  [:a, :b, :c].include?(sampler.sample) or fail
end.call

puts 'Test finished.'
